
#if defined(__cplusplus)
extern "C" {
#endif

#ifndef _RNG_H_
#define _RNG_H_

#include <stdio.h>
#include <malloc.h>
#include <memory.h>
#include "dsa.h"
#include "shaexterns.h"
#include "tdesutil.h"
#include "mp.h"

int  DSAGenX(MP XKey, MP XSeed, int b, MP Q, MP *X, int RndType);
int  DSAGenX_org(MP XKey, MP XSeed, int b, MP Q, MP *X, int rndtype);
int  DSAGenX_CN(MP XKey, MP XSeed, int b, MP Q, MP *X, int rndtype);
int  DSAGenK(MP KKey, int b, MP Q, MP *K, int rndtype);
int  DSAGenK_org(MP KKey, int b, MP Q, MP *K, int rndtype);
int  DSAGenK_CN(MP KKey, int b, MP Q, MP *K, int rndtype);
void shaG(BYTE *tval, BYTE *C, int b, BYTE **G, int hashlen);
void desG(BYTE *t, BYTE *c, BYTE *G);
void ECDSAGenX(MP XKey, MP XSeed, int b, MP N, MP *X, int rndtype);
void ANSIX931Init(TDESCTX *context, BYTE *Key1, BYTE *Key2);
void ANSIX931GenR(TDESCTX *context, BYTE *V, BYTE *DT, BYTE *R);

int  DSARngTest();
int  ECDSARngTest(int rngtype);
int  ANSIX931RngTest();

int RNG_Test();

#endif

#if defined(__cplusplus)
}
#endif